## Index

### Interfaces

- IndexData

### Type aliases

- AttributeModelTypes

### Variables

- KEY_PROPERTY

### Functions

- Property
- createNewProperty
- initOrUpdateGSI
- initOrUpdateIndex
- initOrUpdateLSI
- initOrUpdateProperty
- isCustomType

## Type aliases

### AttributeModelTypes

AttributeModelTypes: string | number | boolean | Date | MomentType | Set<any> | any[]

- Defined in decorator/impl/property/property.decorator.ts:14

## Variables

### Const KEY_PROPERTY

KEY_PROPERTY: "sc-reflect:property" = "sc-reflect:property"

- Defined in decorator/impl/property/property.decorator.ts:12

## Functions

### Property

- Property(opts?: Partial<PropertyData>): PropertyDecorator

- - Defined in decorator/impl/property/property.decorator.ts:21

  #### Parameters

  - ##### Default value opts: Partial<PropertyData> = {}

  #### Returns PropertyDecorator

### createNewProperty

- createNewProperty(propertyOptions?: Partial<PropertyMetadata<any, Attribute>>, target: any, propertyKey: string): PropertyMetadata<any>

- - Defined in decorator/impl/property/property.decorator.ts:104

  #### Parameters

  - ##### Default value propertyOptions: Partial<PropertyMetadata<any, Attribute>> = {}

  - ##### target: any

  - ##### propertyKey: string

  #### Returns PropertyMetadata<any>

### initOrUpdateGSI

- initOrUpdateGSI(indexes: object, indexData: IndexData): Partial<PropertyMetadata<any>>

- - Defined in decorator/impl/property/property.decorator.ts:59

  #### Parameters

  - ##### indexes: object

    - ##### [key: string]: KeyType

  - ##### indexData: IndexData

  #### Returns Partial<PropertyMetadata<any>>

### initOrUpdateIndex

- initOrUpdateIndex(indexType: IndexType, indexData: IndexData, target: any, propertyKey: string): void

- - Defined in decorator/impl/property/property.decorator.ts:34

  #### Parameters

  - ##### indexType: IndexType

  - ##### indexData: IndexData

  - ##### target: any

  - ##### propertyKey: string

  #### Returns void

### initOrUpdateLSI

- initOrUpdateLSI(indexes: string[], indexData: IndexData): Partial<PropertyMetadata<any>>

- - Defined in decorator/impl/property/property.decorator.ts:72

  #### Parameters

  - ##### indexes: string[]

  - ##### indexData: IndexData

  #### Returns Partial<PropertyMetadata<any>>

### initOrUpdateProperty

- initOrUpdateProperty(propertyMetadata?: Partial<PropertyMetadata<any, Attribute>>, target: any, propertyKey: string): void

- - Defined in decorator/impl/property/property.decorator.ts:77

  #### Parameters

  - ##### Default value propertyMetadata: Partial<PropertyMetadata<any, Attribute>> = {}

  - ##### target: any

  - ##### propertyKey: string

  #### Returns void

### isCustomType

- isCustomType(type: AttributeModelTypes): boolean

- - Defined in decorator/impl/property/property.decorator.ts:155

  TODO LOW:BINARY make sure to implement the context dependant details of Binary (Buffer vs. Uint8Array)

  #### Parameters

  - ##### type: AttributeModelTypes

  #### Returns boolean

  true if the type cannot be mapped by dynamo document client

Generated using TypeDoc